metadata: error no matches found

Bug #1433125 reported by kay on 2015-03-17
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
calibre
Undecided
Unassigned

Bug Description

Hi, I have a problem while trying to download metadata from amazon, I was trying to direct calibre to the kindle ed of a book on amazon us website, but it would always find other versions (like an italian version) or even different books. I even tried deleting other parameters and leaving only the ASIN, but then I would get "error no matches found" after a couple seconds.

I'm pasting 5 different logs bellow, the 5th is the only one where calibre finds something, although it finds wrong books (or versions of the book.). Calibre was supposed to find this: http://www.amazon.com/The-Heroes-First-Law-Novel-ebook/dp/B004JHY6OG/ref=tmm_kin_title_0?ie=UTF8&qid=1426600486&sr=1-1

Also, I tried turning off my firewall and antivirus just in case they were interfering, but the results were the same.

windows 8.1 x64
calibre-64bit-2.21.0

Thx!

Here are the logs:

1-

calibre, version 2.21.0
ERROR: No matches found: <p>Failed to find any books that match your search. Try making the search <b>less specific</b>. For example, use only the author's last name and a single distinctive word from the title.<p>To see the full log, click Show Details.

Running identify query with parameters:
{u'authors': [u'Joe Abercrombie'], u'timeout': 30, u'title': u'The Heroes: A First Law Novel', u'identifiers': {u'amazon': u'B004JHY6OG'}}
Using plugins: Amazon.com
The log from individual plugins is below

****************************** Amazon.com ******************************
Request extra headers: [('User-agent', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:2.0.1) Gecko/20100101 Firefox/4.0.1')]
Found 0 results
Downloading from Amazon.com took 2.40200018883
No matches found with identifiers, retrying using only title and authors. Query: u'http://www.amazon.com/s/?field-keywords=B004JHY6OG&sort=relevanceexprank&unfiltered=1&search-alias=aps'
No matches found with query: u'http://www.amazon.com/s/?field-title=Heroes+First+Law+Novel&sort=relevanceexprank&field-author=Joe+Abercrombie&unfiltered=1&search-alias=stripbooks'

********************************************************************************
The identify phase took 2.41 seconds
The longest time (2.402000) was taken by: Amazon.com
Merging results from different sources and finding earliest publication dates from the worldcat.org service
We have 0 merged results, merging took: 0.00 seconds

2-

Running identify query with parameters:
{u'identifiers': {u'amazon': u'B004JHY6OG'}, u'timeout': 30, u'title': u'The Heroes: A First Law Novel', u'authors': [u'Joe Abercrombie']}
Using plugins: Google, Amazon.com
The log from individual plugins is below

****************************** Google ******************************
Request extra headers: [('User-agent', 'Mozilla/5.0 (Windows NT 6.1; rv:6.0) Gecko/20110814 Firefox/6.0')]
Found 0 results
Downloading from Google took 0.563999891281

********************************************************************************

****************************** Amazon.com ******************************
Request extra headers: [('User-agent', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.6; rv:2.0.1) Gecko/20100101 Firefox/4.0.1')]
Found 0 results
Downloading from Amazon.com took 2.04499983788
No matches found with identifiers, retrying using only title and authors. Query: u'http://www.amazon.com/s/?unfiltered=1&search-alias=aps&sort=relevanceexprank&field-keywords=B004JHY6OG'
No matches found with query: u'http://www.amazon.com/s/?unfiltered=1&search-alias=stripbooks&sort=relevanceexprank&field-author=Joe+Abercrombie&field-title=Heroes+First+Law+Novel'

********************************************************************************
The identify phase took 2.21 seconds
The longest time (2.045000) was taken by: Amazon.com
Merging results from different sources and finding earliest publication dates from the worldcat.org service
We have 0 merged results, merging took: 0.00 seconds

3 -

calibre, version 2.21.0
ERROR: No matches found: <p>Failed to find any books that match your search. Try making the search <b>less specific</b>. For example, use only the author's last name and a single distinctive word from the title.<p>To see the full log, click Show Details.

Running identify query with parameters:
{u'authors': None, u'identifiers': {u'amazon': u'B004JHY6OG'}, u'title': None, u'timeout': 30}
Using plugins: Google, Amazon.com
The log from individual plugins is below

****************************** Google ******************************
Request extra headers: [('User-agent', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:2.0.1) Gecko/20100101 Firefox/4.0.1')]
Found 0 results
Downloading from Google took 0.000999927520752
Insufficient metadata to construct query

********************************************************************************

****************************** Amazon.com ******************************
Request extra headers: [('User-agent', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:2.0.1) Gecko/20100101 Firefox/4.0.1')]
Found 0 results
Downloading from Amazon.com took 1.15700006485
No matches found with query: u'http://www.amazon.com/s/?field-keywords=B004JHY6OG&unfiltered=1&search-alias=aps&sort=relevanceexprank'

********************************************************************************
The identify phase took 1.21 seconds
The longest time (1.157000) was taken by: Amazon.com
Merging results from different sources and finding earliest publication dates from the worldcat.org service
We have 0 merged results, merging took: 0.00 seconds

4 -

calibre, version 2.21.0
ERROR: No matches found: <p>Failed to find any books that match your search. Try making the search <b>less specific</b>. For example, use only the author's last name and a single distinctive word from the title.<p>To see the full log, click Show Details.

Running identify query with parameters:
{u'identifiers': {u'amazon': u'B004JHY6OG', u'asin': u'B004JHY6OG'}, u'timeout': 30, u'title': None, u'authors': None}
Using plugins: Google, Amazon.com
The log from individual plugins is below

****************************** Google ******************************
Request extra headers: [('User-agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/534.3 (KHTML, like Gecko) Chrome/6.0.472.63 Safari/534.3')]
Found 0 results
Downloading from Google took 0.00300002098083
Insufficient metadata to construct query

********************************************************************************

****************************** Amazon.com ******************************
Request extra headers: [('User-agent', 'Mozilla/5.0 (Windows NT 6.2; rv:9.0.1) Gecko/20100101 Firefox/9.0.1')]
Found 0 results
Downloading from Amazon.com took 1.06799983978
No matches found with query: u'http://www.amazon.com/s/?unfiltered=1&search-alias=aps&sort=relevanceexprank&field-keywords=B004JHY6OG'

********************************************************************************
The identify phase took 1.21 seconds
The longest time (1.068000) was taken by: Amazon.com
Merging results from different sources and finding earliest publication dates from the worldcat.org service
We have 0 merged results, merging took: 0.00 seconds

5 -

Running identify query with parameters:
{u'authors': [u'Joe Abercrombie'], u'identifiers': {u'asin': u'B004JHY6OG', u'amazon': u'B004JHY6OG'}, u'timeout': 30, u'title': u'The Heroes'}
Using plugins: Google, Amazon.com
The log from individual plugins is below

****************************** Google ******************************
Request extra headers: [('User-agent', 'Mozilla/5.0 (Windows NT 5.2; rv:2.0.1) Gecko/20100101 Firefox/4.0.1')]
Found 2 results
Downloading from Google took 2.01399993896

---
Title : The Heroes: A First Law Novel
Author(s) : Joe Abercrombie
Publisher : Hachette UK
Tags : Fiction, Fantasy, Epic, General
Languages : eng
Rating : 2.3
Published : 2012-05-10T14:42:02.029000+00:00
Identifiers : isbn:9780575105706, google:BensPTQPyZoC
Comments : This enhanced eBook contains: # An introduction from Joe Abercrombie # The full text of THE HEROES # A critical afterword from the editor Plus: # THE FOOL JOBS short story, featuring characters from THE HEROES # A 20,000 word 'planning' document which contains all of Joe's behind-the-scenes notes, plans and timeline for THE HEROES # A before-and-after chapter showing the first draft, the last draft, and many stages in between if one of the most critical chapters of the book # 'Blog archive' - all of Joe's blog posts from the period when he was writing THE HEROES. This is half-diary, half book progress updates, and includes illustrations, links to interviews, events, award ceremonies and reviews of games and books from Joe as well as incidents from his life # A full author biography, and an author photo gallery

---
Title : Heroes: For Glory, for Victory, for Staying Alive
Author(s) : Joe Abercrombie
Publisher : Orbit Us
Languages : eng
Published : 2011-03-15T14:42:02.572000+00:00
Identifiers : isbn:9780316044974, google:a1ccygAACAAJ

********************************************************************************

****************************** Amazon.com ******************************
Request extra headers: [('User-agent', 'Mozilla/5.0 (Windows NT 6.2; rv:9.0.1) Gecko/20100101 Firefox/9.0.1')]
Found 5 results
Downloading from Amazon.com took 7.82800006866

---
Title : The Heroes
Author(s) : Joe Abercrombie
Publisher : Orbit
Languages : eng
Rating : 2.2
Published : 2011-10-21T00:00:00+00:00
Identifiers : isbn:9780316193566, amazon:0316193569
Comments :
They say Black Dow's killed more men than winter, and clawed his way to the throne of the North up a hill of skulls. The King of the Union, ever a jealous neighbor, is not about to stand smiling by while he claws his way any higher. The orders have been given and the armies are toiling through the northern mud. Thousands of men are converging on a forgotten ring of stones, on a worthless hill, in an unimportant valley, and they've brought a lot of sharpened metal with them.
THE HEROES
For glory, for victory, for staying alive.
**

---
Title : The Great Leveller: Best Served Cold, the Heroes and Red Country
Author(s) : Joe Abercrombie
Publisher : Gollancz
Tags : Science Fiction & Fantasy, Fantasy
Languages : eng
Published : 2015-03-26T00:00:00+00:00
Identifiers : amazon:B00RTY15P4
Comments :
Collected together for the first time, here are the three hard-hitting standalone novels set in the world of Joe Abercrombie's bestselling FIRST LAW trilogy.
BEST SERVED COLD: War may be hell but for Monza Murcatto, the Snake of Talins, the most feared and famous mercenary in Duke Orso's employ, it's a damn good way of making money too. Her victories have made her popular - a shade too popular for her employer's taste. Betrayed, thrown down a mountain and left for dead, Murcatto's reward is a broken body and a burning hunger for vengeance. Whatever the cost, seven men must die.
THE HEROES: Over three bloody days of battle, the fate of the North will be decided. But with both sides riddled by intrigues, follies, feuds and petty jealousies, it is unlikely to be the noblest hearts, or even the strongest arms that prevail. Three men. One battle. No Heroes.
RED COUNTRY: Shy South hoped to bury her bloody past and ride away smiling, but she'll have to sharpen up some bad old ways to get her family back, and she's not a woman to flinch from what needs doing. She sets off in pursuit off her family's killers with only a pair of oxen and her cowardly old stepfather Lamb for company. But it turns out Lamb's buried a bloody past of his own, and out in the lawless Far Country, the past never stays buried.
About the Author
Joe Abercrombie is the author of the First Law Trilogy (The Blade Itself, Before They Are Hanged and Last Argument of Kings). His standalone novels (Best Served Cold, The Heroes and Red Country) are also set in the First Law world. His novels have been shortlisted for the World Fantasy Awards, British Fantasy Awards, John W. Campbell Award and the David Gemmell Legend Awards. His covers are also award winning, and have won both the David Gemmell Legend Award and the World Fantasy Award for best artwork. Joe formerly worked as a freelance film editor and is now a full time writer who lives in Bath with his family. Follow @LordGrimDark on twitter for more information, or visit www.joeabercrombie.com.

---
Title : The Heroes [Hardcover]
Author(s) : Joe Abercrombie
Publisher : Orbit
Rating : 2.2
Published : 2011-03-15T00:00:00+00:00
Identifiers : amazon:B004MRB8FI

---
Title : By Joe Abercrombie the Heroes (1st Edition)
Author(s) : Joe Abercrombie
Publisher : Orbit
Languages : eng
Published : 2011-02-22T00:00:00+00:00
Identifiers : amazon:B00AA2Q39A

---
Title : The heroes
Author(s) : Joe Abercrombie
Publisher : Gargoyle
Languages : ita
Published : 2012-01-02T00:00:00+00:00
Identifiers : isbn:9788889541784, amazon:8889541784
No matches found with identifiers, retrying using only title and authors. Query: u'http://www.amazon.com/s/?unfiltered=1&field-keywords=B004JHY6OG&sort=relevanceexprank&search-alias=aps'

********************************************************************************
The identify phase took 8.02 seconds
The longest time (7.828000) was taken by: Amazon.com
Merging results from different sources and finding earliest publication dates from the worldcat.org service
We have 4 merged results, merging took: 1.73 seconds

Thanks!

kay (kthulhu7) on 2015-03-17
description: updated

This is how the amazon.com server works currently. Amazon does not
return Kindle editions of that book in the search results unless you are
logged in. Try it for yourself, log out of amazon (or better use the
private browsing mode) in your browser then search for B004JHY6OG, you
will get no results. Log back in and repeat the search and you will get
the Kindle edition.

Remove the ASIN from the metadata and change the title to "The Heroes"
and you will get results. The title "The Heroes: A First Law Novel" is
only found in the Kindle edition, so it again will not work.

I have no clue why the amazon server is behaving this way, but there is
nothing calibre can do to make up for it's misbehavior. You can try
reporting the misbehavior to amazon, but I wouldn't hold my breath.

 status invalid

Changed in calibre:
status: New → Invalid
kay (kthulhu7) wrote :

Indeed, sorry to trouble you with that, I'll check further before submitting a bug next time. Anyway, the way to work around it was to direct calibre to amazon.uk, as the same book is available there.

Thanks again. Calibre is awesome and you totally rock! :)

kay (kthulhu7) wrote :

Just a thought. Once one has found the link manually, is there a way to "feed it" to calibre.

like:

http://www.amazon.com/dp/B004JHY6OG/ref=r_soa_w_d

(I wonder what the ref=r_soa_w_d is about...

thanks again:)

Kovid Goyal (kovid) wrote :

You can use an ISBN or ASIN for the page your have identified. As long
as the page is not for a Kindle edition, it should work. I know of no
reliable universal addressing scheme for amazon product pages.

Kovid Goyal (kovid) wrote :

Given an ASIN, a URL of the form:
http://www.amazon.com/gp/product/{asin} seems to work, at least on
amazon.com, but I dont know reliable that is.

Fixed in branch master. The fix will be in the next release. calibre is usually released every Friday.

 status fixreleased

Kovid Goyal (kovid) wrote :
Changed in calibre:
status: Invalid → Fix Released
kay (kthulhu7) wrote :

Awesome, thanks:)

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers